import 'package:flutter/material.dart';
import '../../viewmodels/viewmodels.dart';
import '/models/models.dart';
import '/widgets/widgets.dart';
import 'package:intl/intl.dart';
import 'package:omni_datetime_picker/omni_datetime_picker.dart';
import 'package:provider/provider.dart';

import '/widgets/widgets_components.dart' as clase;

class HomeScreen extends StatefulWidget {
  static const String route = '/home';

  const HomeScreen({super.key});

  @override
  Formulario createState() => Formulario();
}

class Formulario extends State<HomeScreen> {
  DateTime? fechaInicio = DateTime.now();
  DateTime? fechaFin;
  ScrollController horizontalScrollController = ScrollController();
  ScrollController verticalScrollController = ScrollController();
  TextEditingController _tipo = TextEditingController(text: 'AUTOTANQUE');
  final _busquedaEmpresa = TextEditingController();
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    double screenWidth = MediaQuery.of(context).size.width;
    final isMobile = screenWidth < 1000;
    final double? columnSpacing = isMobile ? null : 0;
    String nombre = Provider.of<LoginViewModel>(context).nombre;
    String correo = Provider.of<LoginViewModel>(context).correo;
    TextStyle estilo =
        const TextStyle(fontWeight: FontWeight.bold, fontSize: 9);
    TextStyle estiloNumero =
        const TextStyle(fontWeight: FontWeight.bold, fontSize: 22);
    var tvm = Provider.of<AdministracionViewModel>(context);

    return Scaffold(
      backgroundColor: Colors.grey.shade200,
      drawer: AppDrawer(),
      appBar: encabezado(
        titulo: 'Inicio',
      ),
      body: Column(children: []),
    );
  }
}
